### R code from vignette source 'cr_3.Rnw'

###################################################
### code chunk number 1: cr_3.Rnw:120-139
###################################################
par(mfrow=c(2,2))   # 2x2 matrix of plots in one figure
#
plot(Clay1,Clay2); abline(0,1,lty=2);
title("default axes, subsoil vs. topsoil")
abline(h=mean(Clay2)); abline(v=mean(Clay1))
#
plot(Clay1,Clay2,xlim=c(0,100),ylim=c(0,100),pch=20); abline(0,1,lty=2)
title("axes 0..100, subsoil vs. topsoil")
abline(h=mean(Clay2)); abline(v=mean(Clay1))
#
plot(Clay2,Clay1); abline(0,1,lty=2)
title("default axes, topsoil vs. subsoil")
abline(h=mean(Clay1)); abline(v=mean(Clay2))
#
plot(Clay2,Clay1,xlim=c(0,100),ylim=c(0,100),pch=20); abline(0,1,lty=2)
title("axes 0..100, topsoil vs. subsoil")
abline(h=mean(Clay1)); abline(v=mean(Clay2))
#
par(mfrow=c(1,1))  # reset to 1 plot per figure


###################################################
### code chunk number 2: cr_3.Rnw:156-179
###################################################
par(mfrow=c(2,2))
#
plot(Clay1, Clay2, xlim=c(0,80), ylim=c(0,80),
     pch=as.numeric(wrb1))
abline(0,1,lty=2)
abline(h=mean(Clay2)); abline(v=mean(Clay1))
legend(60, 20, legend=levels(wrb1), pch=1:nlevels(wrb1), bty="n")
#
plot(Clay1, Clay2, xlim=c(0,80), ylim=c(0,80), pch=20,
     col=as.numeric(wrb1))
legend(60, 20, legend=levels(wrb1), pch=20,
         col=1:nlevels(wrb1), bty="n")
abline(0, 1, lty=2)
abline(h=mean(Clay2)); abline(v=mean(Clay1))
#
plot(Clay1, Clay2, xlim=c(0,80), ylim=c(0,80),
     pch=as.numeric(wrb1), col=as.numeric(wrb1))
abline(0, 1, lty=2, col=5)
abline(h=mean(Clay2)); abline(v=mean(Clay1))
legend(60, 20, levels(wrb1), pch=1:nlevels(wrb1),
     col=1:nlevels(wrb1), bty="n")
#
par(mfrow=c(1,1))


###################################################
### code chunk number 3: cr_3.Rnw:213-219
###################################################
sum((Clay2-mean(Clay2))*(Clay1-mean(Clay1)))/(length(Clay2)-1)
cov(Clay1,Clay2)
sd(Clay1); sd(Clay2)
cov(Clay1,Clay2)/(sd(Clay1)*sd(Clay2))
cor(Clay1,Clay2)
cor.test(Clay1,Clay2)


###################################################
### code chunk number 4: cr_3.Rnw:255-259
###################################################
plot(Clay2 ~ Clay1, pch=20,col=as.numeric(wrb1))
legend(60, 20, legend=levels(wrb1), pch=20, col=1:nlevels(wrb1), bty="n")
lines(lowess(Clay1, Clay2), lwd=2, col="blue")
abline(lm(Clay2 ~ Clay1), lty=2)


###################################################
### code chunk number 5: cr_3.Rnw:273-278
###################################################
plot(Clay1,Clay2,pch=20,col=as.numeric(wrb1))
legend(60, 20, legend=levels(wrb1),pch=20, col=1:3,bty="n")
for (f in c(0.1, .5, 2/3, 1)) {
  lines(lowess(Clay1, Clay2, f=f), lwd=2) }
abline(lm(Clay2 ~ Clay1), lty=2)


###################################################
### code chunk number 6: cr_3.Rnw:302-304
###################################################
lm21<-lm(Clay2 ~ Clay1)
summary(lm21)


###################################################
### code chunk number 7: cr_3.Rnw:332-336
###################################################
plot(Clay1, Clay2, pch=20)
title("Ordinary least-squares regression, subsoil vs. topsoil clay")
abline(lm21)  
segments(Clay1, Clay2, Clay1, fitted(lm21), lty=2)


###################################################
### code chunk number 8: cr_3.Rnw:354-355
###################################################
lm12<-lm(Clay1 ~ Clay2) ; summary(lm12)


###################################################
### code chunk number 9: cr_3.Rnw:401-404
###################################################
s2x<-var(Clay1); s2x
s2y<-var(Clay2); s2y
sxy<-var(Clay1,Clay2); sxy


###################################################
### code chunk number 10: cr_3.Rnw:409-412
###################################################
sum((Clay1-mean(Clay1))^2)/(length(Clay1)-1)
sum((Clay2-mean(Clay2))^2)/(length(Clay2)-1)
sum((Clay2-mean(Clay2))*(Clay1-mean(Clay1)))/(length(Clay1)-1)


###################################################
### code chunk number 11: cr_3.Rnw:439-443
###################################################
byx<-sxy/s2x; byx
ayx<-mean(Clay2)-byx*mean(Clay1); ayx
bxy<-sxy/s2y; bxy
axy<-mean(Clay1)-bxy*mean(Clay2); axy


###################################################
### code chunk number 12: cr_3.Rnw:476-480
###################################################
plot(fitted(lm21),Clay2,pch=20,xlab="Fitted",ylab="Observed",
   xlim=c(5,85),ylim=c(5,85),main="Observed vs. Fitted Clay %, 0-10cm")
abline(0,1)
segments(fitted(lm21),Clay2,fitted(lm21),fitted(lm21))


###################################################
### code chunk number 13: cr_3.Rnw:508-517
###################################################
plot(fitted(lm21), resid(lm21), pch=20, xlab="Fitted", ylab="Residual",
   main="Regression Residuals vs. Fitted Values, subsoil clay %")
sdres <- sd(residuals(lm21))
for (j in -3:3) abline(h=j*sqrt(var(resid(lm21))), col=abs(j)+1)
ix<-which(abs(resid(lm21))>2*sdres)
text(fitted(lm21)[ix], resid(lm21)[ix], ix, pos=4)
cbind(obs[ix,c("Clay1","Clay2")], fit=round(fitted(lm21)[ix],1),
   resid=round(resid(lm21)[ix],1))
rm(sdres, ix)


###################################################
### code chunk number 14: cr_3.Rnw:539-540
###################################################
stem(residuals(lm21), scale=2)


###################################################
### code chunk number 15: cr_3.Rnw:558-560
###################################################
qqnorm(residuals(lm21))
qqline(residuals(lm21))


###################################################
### code chunk number 16: cr_3.Rnw:578-579
###################################################
shapiro.test(residuals(lm21))


###################################################
### code chunk number 17: cr_3.Rnw:616-635
###################################################
par(mfrow=c(1,2))
h <- hatvalues(lm21)
hi.lev <- which(h>3*mean(h)); hi.lev
Clay1[hi.lev]
(sort.list(Clay1))[(length(Clay1)-5):length(Clay1)]
(sort.list(Clay1))[1:5]
#
plot(Clay1,h);  abline(v=mean(Clay1),lty=2)
  abline(h=seq(1:3)*mean(h),col=c(1,4,2))
  points(Clay1[hi.lev],hatvalues(lm21)[hi.lev],pch=20,col=2,cex=2.5)
  text(Clay1[hi.lev],hatvalues(lm21)[hi.lev],paste("obs", hi.lev),adj=1.5)
#
plot(Clay1,Clay2); abline(lm21)
  points(Clay1[hi.lev],Clay2[hi.lev],pch=20,col=2,cex=2.5)
  text(Clay1[hi.lev],Clay2[hi.lev],paste("obs", hi.lev),adj=1.5)
#
lm21.2 <- lm(Clay2~Clay1,subset=-hi.lev)
round(coefficients(lm21), 3); round(coefficients(lm21.2), 3)
par(mfrow=c(1,1))


###################################################
### code chunk number 18: cr_3.Rnw:655-659
###################################################
sqrt(sum(residuals(lm21)^2)/length(residuals(lm21)))
sqrt(sum(residuals(lm21.2)^2)/length(residuals(lm21.2)))
1-(sum(residuals(lm21)^2)/sum((Clay2-mean(Clay2))^2))
1-(sum(residuals(lm21.2)^2)/sum((Clay2[-hi.lev]-mean(Clay2[-hi.lev]))^2))


###################################################
### code chunk number 19: dfbeta
###################################################
# -- most influential
dfb.lm21 <- dfbeta(lm21)[,2]
head(ix.dfb <- order(abs(dfb.lm21), decreasing=TRUE))
dfb.lm21[ix.dfb[1:5]]
# -- compare with the regression coefficient and its standard error
summary(lm21)$coefficients["Clay1",1:2]
# -- standardized
dfbs.lm21 <- dfbetas(lm21)[,2]
# -- rule-of-thumb cutoff, depends on sample size
(dfbetas.cutoff <- 2/sqrt(dim(obs)[1]))
ix.dfbs.gt <- which(abs(dfbs.lm21) > dfbetas.cutoff)
sort(dfbs.lm21[ix.dfbs.gt])
# -- what was their predictor value?
obs[ix.dfbs.gt,c("Clay1","Clay2")]


###################################################
### code chunk number 20: cr_3.Rnw:787-788
###################################################
round(6.0354+0.9821*55,0)  


###################################################
### code chunk number 21: cr_3.Rnw:793-795
###################################################
pred <- predict(lm21,data.frame(Clay1 = 55),se.fit=T); str(pred)
round(pred$fit + qt(c(.025,.975), pred$df) * pred$se.fit, 1)


###################################################
### code chunk number 22: cr_3.Rnw:823-828
###################################################
pframe <- data.frame(Clay1=seq(min(Clay1), max(Clay1), by=1))
pred.c <- predict(lm21, pframe, interval="confidence", level=.95)
str(pred.c)
pred.p <- predict(lm21, pframe, interval="prediction", level=.95)
str(pred.p)


###################################################
### code chunk number 23: cr_3.Rnw:837-838
###################################################
pred.c[55+1-min(Clay1),]; pred.p[55+1-min(Clay1),]


###################################################
### code chunk number 24: cr_3.Rnw:855-863
###################################################
plot(pframe$Clay1,type="n",pred.c[,"fit"],xlab="Clay 0-10cm",
 ylab="Clay 20-30cm",xlim=c(0,80),ylim=c(0,80))
lines(pframe$Clay1,pred.c[,"fit"],lwd=2)
lines(pframe$Clay1,pred.c[,"lwr"],col=2,lwd=1.5)
lines(pframe$Clay1,pred.c[,"upr"],col=2,lwd=1.5)
lines(pframe$Clay1,pred.p[,"lwr"],col=4,lwd=1.5)
lines(pframe$Clay1,pred.p[,"upr"],col=4,lwd=1.5)
points(Clay1,Clay2)


###################################################
### code chunk number 25: cr_3.Rnw:895-906
###################################################
require(MASS)
lm21.r <- lqs(Clay2 ~ Clay1)
lm21 <- lm(Clay2 ~ Clay1)
class(lm21.r)
class(lm21)
summary(lm21.r)
summary(lm21)
coefficients(lm21.r)
coefficients(lm21)
1-sum(residuals(lm21.r)^2)/sum((Clay2-mean(Clay2))^2)
1-sum(residuals(lm21)^2)/sum((Clay2-mean(Clay2))^2)


###################################################
### code chunk number 26: cr_3.Rnw:915-920
###################################################
plot(Clay2 ~ Clay1, data=obs, xlab="Topsoil clay %",
                                                ylab="Subsoil clay %", main="Two regressions")
abline(lm21, lty=2)
abline(lm21.r, lty=1)
legend(50,30, legend=c("Robust","Least-squares"), lty=1:2)


###################################################
### code chunk number 27: cr_3.Rnw:1035-1042
###################################################
eqn18 <- function(y, x, lambda) {
  a <- var(y)-lambda*var(x);
  c <- var(x,y);
  (a + sqrt(a^2 + 4 * lambda * c^2))/(2*c)
}
eqn18(Clay2,Clay1,1)
eqn18(Clay2,Clay1,var(Clay2)/var(Clay1))


###################################################
### code chunk number 28: cr_3.Rnw:1049-1052
###################################################
lm21$coeff[2]
1/(lm21$coeff[2])
eqn18(Clay2,Clay1,1)


###################################################
### code chunk number 29: cr_3.Rnw:1057-1079
###################################################
s2x <- var(Clay1); s2y <- var(Clay2); sxy <- var(Clay1,Clay2)
byx <- sxy/s2x; ayx <- mean(Clay2)-byx*mean(Clay1)
bxyi <- 1/(sxy/s2y); axyi <- mean(Clay2)-bxyi*mean(Clay1)
b <- sqrt(s2y/s2x); a <- mean(Clay2)-b*mean(Clay1)
bp <- eqn18(Clay2,Clay1,1)
ap <- mean(Clay2)-bp*mean(Clay1)
plot(Clay1,Clay2,xlim=c(5,80),ylim=c(8,80))
par(adj=0.5); title("Correlation and regression","Clay 10-20 cm vs. Clay 0-10 cm")
par(adj=0); abline(ayx,byx,col=1,lty=1)
text(40,8,paste("Clay2 on Clay1; b=",round(byx,4),"; a=",round(ayx,2),sep=""),
     col=1)
abline(axyi,bxyi,col=2,lty=2)
text(40,12,paste("Clay1 on Clay2; b=",round(bxyi,4),"; a=",round(axyi,2),sep=""),
     col=2)
abline(a,b,col=3,lty=3)
text(40,16,paste("Proportional variance; b=",round(b,4),"; a=",round(a,2),sep=""),
     col=3)
abline(ap,bp,col=4,lty=4)
text(40,20,paste("Equal variance; b=",round(bp,4),"; a=",round(ap,2),sep=""),
     col=4)
text(8,70,paste("r = ",round(cor(Clay1,Clay2),4),"; r**2 = ",
     round((cor(Clay1,Clay2)^2)*100,1),"%",sep=""))


###################################################
### code chunk number 30: cr_3.Rnw:1108-1115
###################################################
pc <- princomp(cbind(Clay1,Clay2))
pc$loadings
b <- pc$loadings["Clay2","Comp.1"]/pc$loadings["Clay1","Comp.1"]; b
b <- pc$loadings[2,1]/pc$loadings[1,1]; b
a <- mean(Clay2)-b*mean(Clay1); a
pc$sdev
as.numeric(round(pc$sdev[1]/sum(pc$sdev)*100,1))


###################################################
### code chunk number 31: cr_3.Rnw:1135-1145
###################################################
par(mfrow=c(1,2))
plot(Clay1,  CEC1)
plot(Clay1,  CEC1,
      pch=as.numeric(wrb1)+14,
      col=as.numeric(wrb1), cex=1.5)
title("CEC vs clay, topsoil")
legend(10, 26, levels(wrb1),
      pch=as.numeric(levels(wrb1))+14,
      col=as.numeric(levels(wrb1)))
par(mfrow=c(1,1))


###################################################
### code chunk number 32: cr_3.Rnw:1159-1160
###################################################
cor.test(CEC1, Clay1)  


###################################################
### code chunk number 33: cr_3.Rnw:1174-1177
###################################################
model.cec1 <- lm(CEC1 ~ Clay1); summary(model.cec1)
plot(Clay1, CEC1)
abline(model.cec1)


###################################################
### code chunk number 34: cr_3.Rnw:1190-1209
###################################################
plot(fitted(model.cec1),CEC1,pch=20, xlab="Fitted", ylab="Observed",
     xlim=range(CEC1),ylim=range(CEC1))
title("Observed vs. Fitted topsoil CEC"); abline(0,1)
segments(fitted(model.cec1),CEC1,fitted(model.cec1),fitted(model.cec1))
#
sdres  <-  sd(residuals(model.cec1))
plot(fitted(model.cec1), resid(model.cec1), pch=20,
   xlab="Fitted", ylab="Residual",
   main="Regression Residuals vs. Fitted Values, topsoil CEC")
#
for (j in -3:3) abline(h=j*sqrt(var(resid(model.cec1))), col=abs(j)+1)
ix <- which(abs(resid(model.cec1))>2*sdres)
text(fitted(model.cec1)[ix], resid(model.cec1)[ix], ix, pos=4)
cbind(obs[ix,c("Clay1","Clay2")], fit=round(fitted(model.cec1)[ix],1),
   resid=round(resid(model.cec1)[ix],1))
rm(sdres, ix)
#
qqnorm(residuals(model.cec1))
qqline(residuals(model.cec1))


###################################################
### code chunk number 35: cr_3.Rnw:1231-1235
###################################################
head(CEC1, n=10)
head(rank(CEC1), n=10)
head(Clay1, n=10)
head(rank(Clay1), n=10)


###################################################
### code chunk number 36: cr_3.Rnw:1242-1244
###################################################
cor(rank(CEC1),rank(Clay1))
cor(CEC1,Clay1, method="spearman")


###################################################
### code chunk number 37: cr_3.Rnw:1249-1250
###################################################
cor(CEC1,Clay1)


###################################################
### code chunk number 38: cr_3.Rnw:1311-1312
###################################################
cor(Clay2,Clay1)^2


